package com.tiptimes.dao;

import com.tiptimes.ctrl.QuestionnaireVo;
import com.tiptimes.model.*;
import com.tiptimes.model.exportDTO.*;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface QuestionnaireDao {

    Long insertQuestionnaire(QuestionnaireVo questionnaireVo);

    Integer queryQuestionsId(@Param("qnYear") Integer qnYear);

    int insertQuestions(Questions questions);

    List<Questions> queryQuestionsList(@Param("qnYear") Integer qnYear);

    int insertOptions(Options options);

    List<Record> queryRecordList(Record record);

    Questionnaire queryQuestionnaireList(@Param("qnYear") Integer qnYear);

    Long selectRecordId(@Param("questionnaireUuid") Long questionnaireUuid,
                        @Param("createId") String createId);

    Long insertRecord(Record record);

    Integer delAnswer(@Param("recordId") Long recordId);

    Integer insertAnswer(@Param("list") List<Answer> answerList,
                         @Param("recordId") Long recordId);

    Integer updateRecord(Record record);

    Integer delView(@Param("recordId") Long recordId, @Param("questionsId") Long questionsId);

    Integer insertReview(@Param("list") List<Review> list, @Param("recordId") Long recordId);

    List<Answer> selectAnswerByRecordId(@Param("recordId") Long recordId);

    List<Review> selectReviewByRecordId(@Param("recordId") Long recordId);

    List<YearId> selectQnYearId(@Param("qnYear") Integer qnYear);

    Record selectById(Long recordId);

    List<Record> selectRecordList(Record record);

    List<String> selectFileId(@Param("optionId") Long optionId,
                              @Param("recordId") Long recordId);

    List<PerformanceSummary> selectPerformanceSummaryList(PerformanceSummary performanceSummary);

    List<PerformanceSummary> selectPerformanceSummaryListNew(PerformanceSummary performanceSummary);

    List<FullTimeWorkPerson> selectFullTimeWorkPersonList(@Param("recordId") String recordId);

    List<SiteCondition> selectSiteConditionList();

    List<IncubatedEnterprises> selectIncubatedEnterprisesList();

    List<EmploymentSituation> selectEmploymentSituationList();

    List<EntrepreneurshipCourses> selectEntrepreneurshipCoursesList();

    List<SigningMentors> selectSigningMentorsList();

    List<OrganizationActivity> selectOrganizationActivityList();

    List<CompetingSituation> selectCompetingSituationList();

    List<EntrepreneurshipFunding> selectEntrepreneurshipFundingList();

    List<EntrepreneurshipProject> selectEntrepreneurshipProjectList();

    List<EnterprisestAmount> selecEnterprisestAmountList();

    List<EvaluationBorrowing> selectEvaluationBorrowingList();

    List<InnovationWeek> selectInnovationWeekList();

    List<CollegeSituation> selectCollegeSituationList();

    List<EnterprisesIntellectual> selectEnterprisesIntellectualList();

    List<NationalCompetitionAwards> selectNationalCompetitionAwardsList();

    List<EducationCommission> selectEducationCommissionList();

    List<EntrepreneurialProject> selectEntrepreneurialProjectList();

    List<SpaceAndIncubation> selectSpaceAndIncubationList();

    List<PerformanceSummaryTotal> queryGuideAndRewardIndexList();

    List<PerformanceSummaryTotal> queryGuideAndRewardIndexListNew(@Param("qnYear") Integer qnYear);

    Integer updateAnswerScore(Answer answer);

    List<Review> selectAnswerByStatus(@Param("recordId") Long recordId);

    List<Integer> selectAnswerByQuestion(@Param("recordId") Long recordId);

    Review selectOneReviewByRecordIdAndQuestionsId(@Param("recordId") Long recordId, @Param("questionsId") Long questionsId);

    Integer updateOneReviewByRecordIdAndQuestionsId(@Param("review") Review review);

    Integer insertOneReview(@Param("review") Review review);

    List<Review> selectReviewListByRecordId(@Param("recordId") Long recordId);

    List<Record> AboutViewList(Record record);

    List<Record> AboutViewListCopy(Record record);

    List<SiteCondition> selectSiteConditionListTemp(
            @Param("recordId") String recordId,
            @Param("qnYear") Integer qnYear,
            @Param("id1") Integer id1,
            @Param("id2") Integer id2,
            @Param("id3") Integer id3
    );

    List<FullTimeWorkPerson> selectFullTimeWorkPersonListNew(
            @Param("recordId") String recordId,
            @Param("qnYear") Integer qnYear,
            @Param("id9") Integer id9,
            @Param("id10") Integer id10,
            @Param("id11") Integer id11,
            @Param("id12") Integer id12,
            @Param("id13") Integer id13,
            @Param("id14") Integer id14
    );

    List<IncubatedEnterprises> selectIncubatedEnterprisesListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id16") Integer id16,
            @Param("id17") Integer id17,
            @Param("id18") Integer id18,
            @Param("id19") Integer id19,
            @Param("id20") Integer id20
    );

    List<EmploymentSituation> selectEmploymentSituationListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id21") Integer id21,
            @Param("id22") Integer id22,
            @Param("id23") Integer id23,
            @Param("id24") Integer id24
    );

    List<EntrepreneurshipCourses> selectEntrepreneurshipCoursesListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id25") Integer id25,
            @Param("id26") Integer id26,
            @Param("id27") Integer id27,
            @Param("id28") Integer id28,
            @Param("id29") Integer id29,
            @Param("id30") Integer id30,
            @Param("id31") Integer id31,
            @Param("id32") Integer id32,
            @Param("id33") Integer id33,
            @Param("id34") Integer id34
    );

    List<SigningMentors> selectSigningMentorsListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id35") Integer id35,
            @Param("id36") Integer id36,
            @Param("id37") Integer id37,
            @Param("id38") Integer id38,
            @Param("id39") Integer id39,
            @Param("id40") Integer id40,
            @Param("id41") Integer id41,
            @Param("id42") Integer id42,
            @Param("id43") Integer id43,
            @Param("id44") Integer id44,
            @Param("id45") Integer id45,
            @Param("id46") Integer id46,
            @Param("id47") Integer id47,
            @Param("id48") Integer id48,
            @Param("id49") Integer id49,
            @Param("id50") Integer id50,
            @Param("id51") Integer id51
    );


    List<OrganizationActivity> selectOrganizationActivityListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id52") Integer id52,
            @Param("id53") Integer id53,
            @Param("id54") Integer id54,
            @Param("id55") Integer id55,
            @Param("id56") Integer id56
    );

    List<CompetingSituation> selectCompetingSituationListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id57") Integer id57,
            @Param("id58") Integer id58,
            @Param("id59") Integer id59
    );

    List<EntrepreneurshipFunding> selectEntrepreneurshipFundingListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id60") Integer id60
    );

    List<EntrepreneurshipProject> selectEntrepreneurshipProjectListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id62") Integer id62,
            @Param("id63") Integer id63,
            @Param("id64") Integer id64
    );

    List<EnterprisestAmount> selecEnterprisestAmountListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id65") Integer id65,
            @Param("id66") Integer id66,
            @Param("id67") Integer id67
    );

    List<EvaluationBorrowing> selectEvaluationBorrowingListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id68") Integer id68,
            @Param("id69") Integer id69,
            @Param("id70") Integer id70,
            @Param("id71") Integer id71
    );

    List<InnovationWeek> selectInnovationWeekListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id72") Integer id72,
            @Param("id73") Integer id73,
            @Param("id74") Integer id74
    );

    List<CollegeSituation> selectCollegeSituationListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id75") Integer id75,
            @Param("id76") Integer id76
    );

    List<EnterprisesIntellectual> selectEnterprisesIntellectualListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id77") Integer id77,
            @Param("id76") Integer id78,
            @Param("id77") Integer id79,
            @Param("id76") Integer id80,
            @Param("id77") Integer id81
    );

    List<NationalCompetitionAwards> selectNationalCompetitionAwardsListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id82") Integer id82,
            @Param("id83") Integer id83,
            @Param("id84") Integer id84,
            @Param("id85") Integer id85,
            @Param("id86") Integer id86
    );

    List<EducationCommission> selectEducationCommissionListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id87") Integer id87,
            @Param("id88") Integer id88,
            @Param("id89") Integer id89,
            @Param("id90") Integer id90,
            @Param("id91") Integer id91,
            @Param("id92") Integer id92
    );

    List<EntrepreneurialProject> selectEntrepreneurialProjectListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id93") Integer id93,
            @Param("id94") Integer id94,
            @Param("id95") Integer id95,
            @Param("id96") Integer id96
    );

    List<SpaceAndIncubation> selectSpaceAndIncubationListNew(
            @Param("qnYear") Integer qnYear,
            @Param("id97") Integer id97,
            @Param("id98") Integer id98
    );
}
